package cn.itcast.bank;

import java.util.Random;
import java.util.concurrent.Executors;

public class ServiceWindow {
	private CustomerType type = CustomerType.COMMON;
	private int windowId = 1;

	public void setType(CustomerType type) {
		this.type = type;
	}

	public void setWindowId(int windowId) {
		this.windowId = windowId;
	}

	public void start() {
		Executors.newSingleThreadExecutor().execute(new Runnable() {

			@Override
			public void run() {
				while (true) {

					switch (type) {
					case COMMON:
						commonService();
						break;
					case EXPRESS:
						expressService();
						break;
					case VIP:
						vipService();
						break;
					}
				}
			}

		});
	}

	private void commonService() {
		String windowName = "" + windowId + "" + type + "";
		System.out.println(windowName+"ڻȡ");
		Integer number = NumberMacine.getinstance().getCommonManager()
				.fetchServiceNumber();
		if (number != null) {
			long beginTime = System.currentTimeMillis();
			long costTime = System.currentTimeMillis() - beginTime;
			int maxServeTime = Constants.MAX_SERVICE_TIME
					- Constants.MIN_SERVICE_TIME;

			long ServeTime = new Random().nextInt(maxServeTime) + 1
					+ Constants.MIN_SERVICE_TIME;
			try {
				Thread.sleep(ServeTime);
			} catch (InterruptedException e) {
				// TODO Auto-generated catch block
				e.printStackTrace();
			}
			System.out.println(windowName + "Ϊ" + number + "" + type
					+ "ͻɷ񣬺ʱ" + costTime / 1000 + "");
		} else {
			System.out.println(windowName + "ûȡ,Ϣһ");
			//commonService();
			try {
				Thread.sleep(1000);
			} catch (InterruptedException e) {

				e.printStackTrace();
			}
		}
	}

	private void expressService() {
		String windowName = "" + windowId + "" + type + "";
		System.out.println(windowName+"ڻȡ");
		Integer number = NumberMacine.getinstance().getExpressManager()
				.fetchServiceNumber();
		if (number != null) {
			long beginTime = System.currentTimeMillis();
			
			  long costTime = System.currentTimeMillis() - beginTime;
//			  int maxServeTime = Constants.MAX_SERVICE_TIME -
//			  Constants.MIN_SERVICE_TIME;
//			 
//
//			long ServeTime = new Random().nextInt(maxServeTime) + 1
//					+ Constants.MIN_SERVICE_TIME;
			try {
				Thread.sleep(Constants.MIN_SERVICE_TIME);
			} catch (InterruptedException e) {
				// TODO Auto-generated catch block
				e.printStackTrace();
			}
			System.out.println(windowName + "Ϊ" + number + "" + type
					+ "ͻɷ񣬺ʱ" + costTime/1000+ "");
		} else {
			System.out.println(windowName + "ûȡ,Ϣһ");
			commonService();

		}
	}

	private void vipService() {
		String windowName = "" + windowId + "" + type + "";
		System.out.println(windowName+"ڻȡ");
		Integer number = NumberMacine.getinstance().getVipManager()
				.fetchServiceNumber();
		if (number != null) {
			long beginTime = System.currentTimeMillis();
			long costTime = System.currentTimeMillis() - beginTime;
			int maxServeTime = Constants.MAX_SERVICE_TIME
					- Constants.MIN_SERVICE_TIME;

			long ServeTime = new Random().nextInt(maxServeTime) + 1
					+ Constants.MIN_SERVICE_TIME;
			try {
				Thread.sleep(ServeTime);
			} catch (InterruptedException e) {
				// TODO Auto-generated catch block
				e.printStackTrace();
			}
			System.out.println(windowName + "Ϊ" + number + "" + type
					+ "ͻɷ񣬺ʱ" + costTime / 1000 + "");
		} else {
			System.out.println(windowName + "ûȡ");
			commonService();
			try {
				Thread.sleep(1000);
			} catch (InterruptedException e) {

				e.printStackTrace();
			}
		}
	}
}
